// Mark Crossley
// 26 Apr 2006 - Inital version to capture PoD common code
// 31 May 2006 - Added orginal image size code (size = 999)
// 14 Jun 2006 - Added new frame style, and variable status text
// 22 Jun 2006 - Added full entity code handling (at last)
// 01 Jul 2006 - Fixed parseInt call to always use base 10.
// 05 Nov 2006 - Fixed problem of slideout text not hiding correctly


function getPage()
{
	//update the message to inform the user
	statusText.data = strDownloadingPage;

	print("Fetching = " + urlArray[intBrowsePos]);
	url.location = urlArray[intBrowsePos];
	urlArray[intBrowsePos + 1] = "";
	url.fetchAsync(processIt);

	//check for updates
	auto_update();
}

function cleanupText(strText)
{
	try {
		//remove XML data tags
		strText = strText.replace(/&lt!\[CDATA\[/g,"");
		strText = strText.replace(/\]\]&gt/g,"");
		//remove any line breaks in the text
		strText = strText.replace(/\n/g," ");
		//replace multiple blanks with one
		strText = strText.replace(/\s\s+/g, " ");
		strText = strText.replace(/\s\s+/g, " ");
		//add some line feeds
		strText = strText.replace(/<p[^>]*>/g,"\n \n");
		strText = strText.replace(/<\/div>/gi,"\n \n");
		strText = strText.replace(/<br[^>]*>/gi,"\n");
		//remove all other HTMLTags
		strText = strText.replace(/<[^>]*>/g,"");
		
		//replace entity codes with character codes (or actual characters)
		strText = strText.replace(/&[a-zA-Z]+;/g, function(str){return entity2code(str);});
		
print("cleanupText("+strText+")");
		//replace character codes with characters
		strText = strText.replace(/&#([0-9]+);?/g, function(str,p1){return convertDec2Char(p1)});
print("cleanupText("+strText+")");

		//remove LPOD sponsor stuff
		//strText = strText.replace(/support lpod.*/mi,"");
		//strText = strText.replace(/Now you can support LPOD.*/i,"");

		//replace muliple blank lines with a one
		strText = strText.replace(/\n\n/gm,"\n");
		return  strText.replace(/\n\n/gm,"\n"); }
	catch(e) {
		return ""; }
}

function aspect_ratio()
{
	var srcH, srcW, tgtSize;

	// Get the original image dimensions
	srcH = mainImage.srcHeight;
	srcW = mainImage.srcWidth;

	// Get the maximum permitted window size
	tgtSize = preferences.maxSizePref.value;
	print("src WxH: " + srcW + "x" + srcH);

	//if we want a smaller image size than original
	if (tgtSize < 999)
	{
		if (srcH > srcW)
		{
			// The image is higher than wide so...
			// calculate required relative width
			srcW = Math.round((srcW / srcH) * tgtSize);
			srcH = tgtSize;
		}
		else
		{
			// The image is wider than high (or square), so...
			// calculate required relative height
			srcH = (srcH / srcW) * tgtSize;
			srcH = Math.round(srcH);
			srcW = tgtSize;
		}
	}
	print("wgt WxH: " + srcW + "x" + srcH);

	// We have the new dimensions, so resize the widget
	resize_widget(srcW, srcH);
}

function resize_widget(w, h)
{
	//stop the widget updating
	suppressUpdates();

	// assume the params are always integer values
	// multiply by 1 to force into numeric

	// resize the main window, allowing for the border - if required
	mainWindow.width = 1*w + (frame_lm.width + frame_rm.width) * preferences.frameVisiblePref.value;
	mainWindow.height = 1*h + (frame_tm.height + frame_bm.height) * (preferences.frameVisiblePref.value);
	
	if (preferences.textVisiblePref.value == "1"  & preferences.frameVisiblePref.value  == "0")
		// take off the extra height for the frame shadow
		mainWindow.height = mainWindow.height +32 ;
	
	print("window WxH: "+mainWindow.width+"x"+mainWindow.height);

	if (preferences.buttonPosPref.value == "Right" ||
	    preferences.buttonPosPref.value == "Bottom")
	{
		//resposition the slideout button in bottom corner of frame
		button.hOffset = mainWindow.width - (button.width + 2) - (frame_rm.width - frame_lm.width)*preferences.frameVisiblePref.value;
		button.vOffset = mainWindow.height - (button.height + 2) - (frame_bm.height - frame_tm.height) * (preferences.frameVisiblePref.value);
	}
	else
	{
		//resposition the slideout button in top corner of frame
		button.hOffset = 2;
		button.vOffset = 2;
	}
	
	// and the frame
	if (preferences.frameVisiblePref.value == "1")
	{
		frame_tl.visible = true;
		frame_tm.visible = true;
		frame_tr.visible = true;
		frame_lm.visible = true;
		frame_rm.visible = true;
		frame_bl.visible = true;
		frame_bm.visible = true;
		frame_br.visible = true;
		
		frame_tm.width = w*1;
		frame_tm.hOffset = frame_lm.width;
		frame_tr.hOffset = w*1 + frame_lm.width;
		
		frame_lm.height = h;
		frame_lm.vOffset = frame_tm.height;
		
		frame_rm.height = h;
		frame_rm.hOffset = w*1 + frame_lm.width;
		frame_rm.vOffset = frame_tm.height;
		
		frame_bl.vOffset = h*1 + frame_tm.height;
		frame_bm.width = w*1;
		frame_bm.hOffset = frame_lm.width;
		frame_bm.vOffset = h*1 + frame_tm.height;
		frame_br.hOffset = w*1 + frame_lm.width;
		frame_br.vOffset = h*1 + frame_tm.height;
	}
	else
	{
		frame_tl.visible = false;
		frame_tm.visible = false;
		frame_tr.visible = false;
		frame_lm.visible = false;
		frame_rm.visible = false;
		frame_bl.visible = false;
		frame_bm.visible = false;
		frame_br.visible = false;
	}

	// resize the image itself
	mainImage.width = w;
	mainImage.height = h;
	// and position within the window allowing for frame and text
	mainImage.hOffset = frame_lm.width * preferences.frameVisiblePref.value;
	if (preferences.frameVisiblePref.value == "1")
		mainImage.vOffset = frame_tm.height;
	else if (preferences.textVisiblePref.value == "1")
		mainImage.vOffset = 16;
	else
		mainImage.vOffset = 0;

	print("image WxH: "+w+"x"+h);

	if (preferences.textVisiblePref.value == "1")
	{
		// text visible
		statusText.visible = true;
		imageTitle.visible = true;

		// reposition the text at the bottom
		statusText.hOffset = Math.round(mainWindow.width / 2);
		imageTitle.hOffset = statusText.hOffset;

		if (preferences.frameVisiblePref.value == "1")
		{
			statusText.vOffset = mainWindow.height - frame_bm.height/2;
			imageTitle.vOffset = frame_tm.height/2 + imageTitle.height/2 - 2;
		}
		else
		{
			statusText.vOffset = mainWindow.height - 2;
			imageTitle.vOffset = 12;
		}

		print("Title vOffset: " +imageTitle.vOffset + "(" + imageTitle.height+")("+frame_tm.height+")");
	}
	else
	{
		// text hidden
		statusText.visible = false;
		imageTitle.visible = false;
	}

	if(preferences.buttonPosPref.value == "Right")
	{
		print("info on the right");
		button.src = "Resources/Images/right_button.png";
		//reposition and size the slide out info frame
		trayFrameParent.hOffset = mainImage.width + (2 * frame_lm.width * preferences.frameVisiblePref.value);
		trayFrameParent.vOffset = mainImage.vOffset;
		trayFrameParent.width = 250;
		trayFrameParent.height = mainWindow.height - 6;
		infoArea.height = mainImage.height;
		infoArea.width = 250;
	}
	else if(preferences.buttonPosPref.value == "Bottom")
	{
		print("info at the bottom");
		button.src = "Resources/Images/down_button.png";
		//reposition and size the slide out info frame
		trayFrameParent.hOffset = frame_lm.width * preferences.frameVisiblePref.value;
		if (preferences.frameVisiblePref.value == "1")
			trayFrameParent.vOffset = mainImage.height + (2 * frame_tm.height);
		else if (preferences.textVisiblePref.value == "1")
			trayFrameParent.vOffset = mainImage.height + 32;
		else
			trayFrameParent.vOffset = mainImage.height;
		trayFrameParent.height = 250;
		trayFrameParent.width = mainImage.width;
		infoArea.width = mainImage.width;
		infoArea.height = 250;
	}
	else if(preferences.buttonPosPref.value == "Left")
	{
		print("info at the left");
		button.src = "Resources/Images/left_button.png";
		//reposition and size the slide out info frame
		trayFrameParent.vOffset = mainImage.vOffset;
		trayFrameParent.hOffset = 0;			
		trayFrameParent.height = mainWindow.height;
		trayFrameParent.width = 250;
		infoArea.height = mainImage.height;
		infoArea.width = 250;
	}
	else if(preferences.buttonPosPref.value == "Top")
	{
		print("info at the top");
		button.src = "Resources/Images/up_button.png";
		//reposition and size the slide out info frame
		trayFrameParent.hOffset = mainImage.hOffset;
		trayFrameParent.vOffset = 0;
		trayFrameParent.height = 250;
		trayFrameParent.width = mainWindow.width;
		infoArea.height = 250;
		infoArea.width = mainImage.width;
	}

	browseFrame.hOffset = 4;
	browseFrame.vOffset = mainWindow.height - (browseFrame.height + 2) - (frame_bm.height - frame_tm.height) * (preferences.frameVisiblePref.value);

	// window is not visible at first so make it show
	mainWindow.visible = true;
	resumeUpdates();
	updateNow();

}

function fixed_window()
{
	var srcW, srcH;

	if (preferences.maxSizePref.value < 999)
	{
		// the maximum window size applies to width
		srcW = preferences.maxSizePref.value;
		// standard aspect ratio has the height 0.75x the height
		srcH = Math.round(srcW * 0.75);
	}
	else
	{
		//original sized image, so ignore resizing
		srcW = mainImage.srcWidth;
		srcH = mainImage.srcHeight;
	}
	print("fixed window WxH: "+srcW+"x"+srcH);

	// we have the new dimensions, so resize the widget
	resize_widget(srcW, srcH);
}

function extractFrom(data, guard, prefix, suffix)
{
	function x(s) { return s.replace(/([\W])/g,"\\$1"); }
	var lookFor = "";
	if (guard !== "") lookFor += x(guard) + '[.\\s\\S]*?';
	lookFor += x(prefix) + '([.\\s\\S]*?)' + x(suffix);
	var item = data.match(lookFor);
	if (item != null) return item[1];
	return "";
}

function showInfo()
{
	suppressUpdates();
	//the infoArea is hidden by default to hide some ugly loading behaviour
	infoArea.visible = true;
	
	if (blnShowInfo == false) // Show info pane
	{
		if (preferences.buttonPosPref.value == "Right")
		{
			print("showing info (right)...");
			var a = new	MoveAnimation( trayFrame, 0, 0, 350, animator.kEaseInOut);
			mainWindow.width += 250;
			button.src = "Resources/Images/left_button.png";
		}
		else if (preferences.buttonPosPref.value == "Bottom")
		{
			print("showing info (bottom)...");
			var a = new	MoveAnimation( trayFrame, 0, 0, 350, animator.kEaseInOut);
			mainWindow.height += 250;
			button.src = "Resources/Images/up_button.png";
		}
		else if (preferences.buttonPosPref.value == "Left")
		{
			print("showing info (left)...");
			var a = new	MoveAnimation( trayFrame, 0, 0, 350, animator.kEaseInOut);
			mainWindow.hOffset -= 250;
			mainWindow.width += 250;
			widgetFrame.hOffset += 250;
			trayFrame.hOffset += 250;
			button.src = "Resources/Images/right_button.png";
		}
		else if (preferences.buttonPosPref.value == "Top")
		{
			print("showing info (top)...");
			var a = new	MoveAnimation( trayFrame, 0, 0, 350, animator.kEaseInOut);
			mainWindow.vOffset -= 250;
			mainWindow.height += 250;
			widgetFrame.vOffset += 250;
			button.src = "Resources/Images/down_button.png";
		}
		resumeUpdates();
		animator.start( a );
		blnShowInfo = true;
		button.reload();
	}
	else // Hide info pane
	{
		if (preferences.buttonPosPref.value == "Right")
		{
			print("hiding info (right)...");
			var a = new	MoveAnimation( trayFrame, -255, 0, 350, animator.kEaseInOut );
			resumeUpdates();
			animator.runUntilDone( a );
			mainWindow.width -= 250
			button.src = "Resources/Images/right_button.png";
		}
		else if (preferences.buttonPosPref.value == "Bottom")
		{
			print("hiding info (bottom)...");
			var a = new	MoveAnimation( trayFrame, 0, -255, 350, animator.kEaseInOut );
			resumeUpdates();
			animator.runUntilDone( a );
			mainWindow.height -= 250;
			button.src = "Resources/Images/down_button.png";
		}
		else if (preferences.buttonPosPref.value == "Left")
		{
			print("hiding info (left)...");
			var a = new	MoveAnimation( trayFrame, 255, 0, 350, animator.kEaseInOut);
			resumeUpdates();
			animator.runUntilDone( a );
			mainWindow.width -= 250;
			mainWindow.hOffset +=250;
			widgetFrame.hOffset = 0;
			trayFrame.hOffset = 0;
			button.src = "Resources/Images/left_button.png";
		}
		else if (preferences.buttonPosPref.value == "Top")
		{
			print("hiding info (top)...");
			var a = new	MoveAnimation( trayFrame, 0, 255, 350, animator.kEaseInOut);
			resumeUpdates();
			animator.runUntilDone( a );
			mainWindow.height -= 250;
			mainWindow.vOffset +=250;
			widgetFrame.vOffset -= 250;
			button.src = "Resources/Images/up_button.png";
		}
		blnShowInfo = false;
		button.reload();
	}
}

function auto_update()
{
	// does the user want to check for updates?
	if (preferences.autoUpdatePref.value == "0")
		return;

	// check if a month has passed since the last check
	var u, now, update;

	now = new Date();

	u = preferences.lastUpdatePref.value.split("/");
	print("lastUpdatePref: " + preferences.lastUpdatePref.value);

	update = new Date();
	update.setFullYear(u[0],u[1],u[2]);

	print("now: " + now);
	print("update: " + update);

	if (now >= update)
	{
		print("Auto updating...");
		// call the update routine
		var verChk = new VersionChecker(intWidgetID, strWidgetName, widget.version, true );
		verChk.checkVersion();

		// add a month onto the update preference
		now.setMonth(1 + now.getMonth());
		u[0] = now.getFullYear();
		u[1] = now.getMonth();
		u[2] = now.getDate();

		//write the next update date back to the preferences
		preferences.lastUpdatePref.value = u[0] +"/"+ u[1] +"/"+ u[2];
		savePreferences();
	}

}


function browse(dir)
{
	// dir = 99 is special case for preference changes only
	// browsing is relative to 0 = current POD, intBrowseItems = oldest available
	if (dir < 99) intBrowsePos += dir;

	if (dir == 0) //go to current days POD
		intBrowsePos = 0;

	if (preferences.browsePref.value == 1) //do we need to update the buttons?
	{
		if (intBrowsePos == 0) // at current days image
		{
			//hide the forward and now buttons
			nowButton.opacity = forwardButton.opacity = 70;
			nowButton.onMouseDown = forwardButton.onMouseDown = null;
			if (!urlArray[1] == "") //if there is a 'prev' url show the back button
			{
				backButton.opacity = 200;
				backButton.onMouseDown = "browse(1);";
			}
			else  //hide the back button
			{
				backButton.opacity = 70;
				backButton.onMouseDown = null;
			}

		}
		else
		{
			if (!urlArray[1] == "") //if there is a 'prev' url show the back button
			{
				backButton.opacity = 200;
				backButton.onMouseDown = "browse(1);";
			}
			else  //hide the back button
			{
				backButton.opacity = 70;
				backButton.onMouseDown = null;
			}
			//enable all
			forwardButton.opacity = nowButton.opacity = 200;
			forwardButton.onMouseDown = "browse(-1);";
			nowButton.onMouseDown = "browse(0);";
		}
	}
	// OK lets finally show the image, don't if only a preference change
	if (dir < 99) displayIt(intBrowsePos);
}


function displayIt(rec)
{
	print("displayIt; intBrowsePos, intBrowseItems = " +intBrowsePos +", "+ intBrowseItems);
	// is the info panel displayed?  if so hide it before we update
	if (blnShowInfo == true)
		showInfo();
	if (intBrowsePos > intBrowseItems)  //we haven't parsed this page yet
	{
		getPage();				//get the page and parse it before display
		return;
	}

	print("displaying image("+rec+")");
	statusText.data = strDownloadingImage;
	updateNow();
	mainImage.src = imageArray[rec];
	mainImage.reload();
	infoArea.data = titleArray[rec] + "\n\n" + descArray[rec];

	switch (preferences.statusTextPref.value)
	{
		case "d":
			statusText.data = dateArray[rec];
			mainImage.tooltip = titleArray[rec];
			break;
		case "t":
			statusText.data = titleArray[rec];
			mainImage.tooltip = dateArray[rec];
			break;
		default:
			statusText.data = dateArray[rec];
			mainImage.tooltip = titleArray[rec];
	}

	if (preferences.aspectRatioPref.value == "1")
	{
		// If we have selected to correct aspect ratios
		aspect_ratio();
	}
	else
	{
		// reset window to selected size
		fixed_window();
	}

}

function entity2code(str)
{
	// Converts from string entity codes to numeric codes
	switch (str)
	{
		case "&quot;"  :	return "&#34;"; 	// "   double quotation mark 
		case "&amp;"   :	return "&#38;"; 	// &   ampersand 
		case "&frasl;" :	return "&#47;"; 	// /   slash 
		case "&lt;"    :	return "&#60;"; 	// <   less-than sign 
		case "&gt;"    :	return "&#62;"; 	// >   greater-than sign 
		case "&ndash;" :	return "&#150;";	// –   en dash 
		case "&mdash;" :	return "&#151;";	// —   em dash 
		case "&nbsp;"  :	return "&#160;";	//     nonbreaking space 
		case "&iexcl;" :	return "&#161;";	// ¡   inverted exclamation 
		case "&cent;"  :	return "&#162;";	// ¢   cent sign 
		case "&pound;" :	return "&#163;";	// £   pound sterling 
		case "&curren;":	return "&#164;";	// ¤   general currency sign 
		case "&yen;"   :	return "&#165;";	// ¥   yen sign 
		case "&brvbar;":	return "&#166;";	// ¦   broken vertical bar
		case "&brkbar;":	return "&#166;";	// ¦   broken vertical bar 
		case "&sect;"  :	return "&#167;";	// §   section sign 
		case "&uml;"   :	return "&#168;";	// ¨   umlaut 
		case "&die;"   :	return "&#168;";	// ¨   umlaut 
		case "&copy;"  :	return "&#169;";	// ©   copyright 
		case "&ordf;"  :	return "&#170;";	// ª   feminine ordinal 
		case "&laquo;" :	return "&#171;";	// «   left angle quote 
		case "&not;"   :	return "&#172;";	// ¬   not sign 
		case "&shy;"   :	return "&#173;";	// ­   soft hyphen 
		case "&reg;"   :	return "&#174;";	// ®   registered trademark 
		case "&macr;"  :	return "&#175;";	// ¯   macron accent
		case "&hibar;" :	return "&#175;";	// ¯   macron accent 
		case "&deg;"   :	return "&#176;";	// °   degree sign 
		case "&plusmn;":	return "&#177;";	// ±   plus or minus 
		case "&sup2;"  :	return "&#178;";	// ²   superscript two 
		case "&sup3;"  :	return "&#179;";	// ³   superscript three 
		case "&acute;" :	return "&#180;";	// ´   acute accent 
		case "&micro;" :	return "&#181;";	// µ   micro sign 
		case "&para;"  :	return "&#182;";	// ¶   paragraph sign 
		case "&middot;":	return "&#183;";	// ·   middle dot 
		case "&cedil;" :	return "&#184;";	// ¸   cedilla 
		case "&sup1;"  :	return "&#185;";	// ¹   superscript one 
		case "&ordm;"  :	return "&#186;";	// º   masculine ordinal 
		case "&raquo;" :	return "&#187;";	// »   right angle quote 
		case "&frac14;":	return "&#188;";	// ¼   one-fourth 
		case "&frac12;":	return "&#189;";	// ½   one-half 
		case "&frac34;":	return "&#190;";	// ¾   three-fourths 
		case "&iquest;":	return "&#191;";	// ¿   inverted question mark 
		case "&Agrave;":	return "&#192;";	// À   uppercase A, grave accent 
		case "&Aacute;":	return "&#193;";	// Á   uppercase A, acute accent 
		case "Acirc;"  :	return "&#194;";	// Â   uppercase A, circumflex accent 
		case "&Atilde;":	return "&#195;";	// Ã   uppercase A, tilde 
		case "&Auml;"  :	return "&#196;";	// Ä   uppercase A, umlaut 
		case "&Aring;" :	return "&#197;";	// Å   uppercase A, ring 
		case "&AElig;" :	return "&#198;";	// Æ   uppercase AE 
		case "&Ccedil;":	return "&#199;";	// Ç   uppercase C, cedilla 
		case "&Egrave;":	return "&#200;";	// È   uppercase E, grave accent 
		case "&Eacute;":	return "&#201;";	// É   uppercase E, acute accent 
		case "&Ecirc;" :	return "&#202;";	// Ê   uppercase E, circumflex accent 
		case "&Euml;"  :	return "&#203;";	// Ë   uppercase E, umlaut 
		case "&Igrave;":	return "&#204;";	// Ì   uppercase I, grave accent 
		case "&Iacute;":	return "&#205;";	// Í   uppercase I, acute accent 
		case "&Icirc;" :	return "&#206;";	// Î   uppercase I, circumflex accent 
		case "&Iuml;"  :	return "&#207;";	// Ï   uppercase I, umlaut 
		case "&ETH;"   :	return "&#208;";	// Ð   uppercase Eth, Icelandic 
		case "&Ntilde;":	return "&#209;";	// Ñ   uppercase N, tilde 
		case "&Ograve;":	return "&#210;";	// Ò   uppercase O, grave accent 
		case "&Oacute;":	return "&#211;";	// Ó   uppercase O, acute accent 
		case "&Ocirc;" :	return "&#212;";	// Ô   uppercase O, circumflex accent 
		case "&Otilde;":	return "&#213;";	// Õ   uppercase O, tilde 
		case "&Ouml;"  :	return "&#214;";	// Ö   uppercase O, umlaut 
		case "&times;" :	return "&#215;";	// ×   multiplication sign 
		case "&Oslash;":	return "&#216;";	// Ø   uppercase O, slash 
		case "&Ugrave;":	return "&#217;";	// Ù   uppercase U, grave accent 
		case "&Uacute;":	return "&#218;";	// Ú   uppercase U, acute accent 
		case "&Ucirc;" :	return "&#219;";	// Û   uppercase U, circumflex accent 
		case "&Uuml;"  :	return "&#220;";	// Ü   uppercase U, umlaut 
		case "&Yacute;":	return "&#221;";	// Ý   uppercase Y, acute accent 
		case "&THORN;" :	return "&#222;";	// Þ   uppercase THORN, Icelandic 
		case "&szlig;" :	return "&#223;";	// ß   lowercase sharps, German 
		case "&agrave;":	return "&#224;";	// à   lowercase a, grave accent 
		case "&aacute;":	return "&#225;";	// á   lowercase a, acute accent 
		case "&acirc;" :	return "&#226;";	// â   lowercase a, circumflex accent 
		case "&atilde;":	return "&#227;";	// ã   lowercase a, tilde 
		case "&auml;"  :	return "&#228;";	// ä   lowercase a, umlaut 
		case "&aring;" :	return "&#229;";	// å   lowercase a, ring 
		case "&aelig;" :	return "&#230;";	// æ   lowercase ae 
		case "&ccedil;":	return "&#231;";	// ç   lowercase c, cedilla 
		case "&egrave;":	return "&#232;";	// è   lowercase e, grave accent 
		case "&eacute;":	return "&#233;";	// é   lowercase e, acute accent 
		case "&ecirc;" :	return "&#234;";	// ê   lowercase e, circumflex accent 
		case "&euml;"  :	return "&#235;";	// ë   lowercase e, umlaut 
		case "&igrave;":	return "&#236;";	// ì   lowercase i, grave accent 
		case "&iacute;":	return "&#237;";	// í   lowercase i, acute accent 
		case "&icirc;" :	return "&#238;";	// î   lowercase i, circumflex accent 
		case "&iuml;"  :	return "&#239;";	// ï   lowercase i, umlaut 
		case "&eth;"   :	return "&#240;";	// ð   lowercase eth, Icelandic 
		case "&ntilde;":	return "&#241;";	// ñ   lowercase n, tilde 
		case "&ograve;":	return "&#242;";	// ò   lowercase o, grave accent 
		case "&oacute;":	return "&#243;";	// ó   lowercase o, acute accent 
		case "&ocirc;" :	return "&#244;";	// ô   lowercase o, circumflex accent 
		case "&otilde;":	return "&#245;";	// õ   lowercase o, tilde 
		case "&ouml;"  :	return "&#246;";	// ö   lowercase o, umlaut 
		case "&divide;":	return "&#247;";	// ÷   division sign 
		case "&oslash;":	return "&#248;";	// ø   lowercase o, slash 
		case "&ugrave;":	return "&#249;";	// ù   lowercase u, grave accent 
		case "&uacute;":	return "&#250;";	// ú   lowercase u, acute accent 
		case "&ucirc;" :	return "&#251;";	// û   lowercase u, circumflex accent 
		case "&uuml;"  :	return "&#252;";	// ü   lowercase u, umlaut 
		case "&yacute;":	return "&#253;";	// ý   lowercase y, acute accent 
		case "&thorn;" :	return "&#254;";	// þ   lowercase thorn, Icelandic 
		case "&yuml;"  :	return "&#255;";	// ÿ   lowercase y, umlaut 
		case "&lsquo;" :	return "‘";	// left single quote 
		case "&rsquo;" :	return "’";	// right single quote 
		case "&sbquo;" :	return "‚";	// single low-9 quote 
		case "&ldquo;" :	return "“";	// left double quote 
		case "&rdquo;" :	return "”";	// right double quote 
		case "&bdquo;" :	return "„";	// double low-9 quote 
		case "&dagger;":	return "†";	// dagger 
		case "&Dagger;":	return "‡";	// double dagger 
		case "&permil;":	return "‰";	// per mill sign 
		case "&lsaquo;":	return "‹";	// single left-pointing angle quote 
		case "&rsaquo;":	return "›";	// single right-pointing angle quote 
		case "&spades;":	return "?";	// black spade suit 
		case "&clubs;" :	return "?";	// black club suit 
		case "&hearts;":	return "?";	// black heart suit 
		case "&diams;" :	return "?";	// black diamond suit 
		case "&oline;" :	return "?";	// overline, = spacing overscore 
		case "&larr;"  :	return "?";	// leftward arrow 
		case "&uarr;"  :	return "?";	// upward arrow 
		case "&rarr;"  :	return "?";	// rightward arrow 
		case "&darr;"  :	return "?";	// downward arrow 
		case "&trade;" :	return "™";	// trademark sign 
		default        :	return str;	// Otherwise return the original string
	}
}

function convertDec2Char(str)
{
	var outputString = '';
	var n = parseInt(str,10);
	if (n <= 0xFFFF)
	{
		outputString = String.fromCharCode(n);
	}
	else if (n <= 0x10FFFF)
	{
		n -= 0x10000;
		outputString = String.fromCharCode(0xD800 | (n >> 10)) + String.fromCharCode(0xDC00 | (n & 0x3FF));
	}
	else
	{
		outputString = ' ';
	}
	return(outputString);
}
